## meganz-sdk-v8.3.1.tar.gz

=== CMakeLists.txt ===
# CMakeLists.txt file to build the SDKlib library.
#
# It can be used to build a standalone library or to be included via add_subdirectory.
#
# To include the project in your application use the following:
#    add_subdirectory(path/to/sdk)
#    target_link_libraries(<target> PRIVATE MEGA::SDKlib)
#
# To use it as a standalone library, once compiled and installed:
#    find_package(SDKlib REQUIRED)
#    target_link_libraries(<target> PRIVATE MEGA::SDKlib)
# If you prefer to use pkg-config, use the following instead:
#    pkg_check_modules(SDKlib REQUIRED IMPORTED_TARGET SDKlib)
#    target_link_libraries(<target> PRIVATE PkgConfig::SDKlib)
#

cmake_minimum_required(VERSION 3.18)

# Qt Creator configures VCPKG automatically. Disable it, we may want to use different tripplets, paths...
set(QT_CREATOR_SKIP_VCPKG_SETUP TRUE CACHE BOOL "")

# Main modules location
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/cmake/modules)

set(VCPKG_ROOT "" CACHE PATH "If set, it will build and use the VCPKG packages defined in the manifest file")

# Set up CMAKE_SYSTEM_NAME for cross compiling
if (VCPKG_ROOT)
    include(set_cmake_system_name)
    set_cmake_system_name()
endif()

## Configurable options ##
include(sdklib_options)

# If PROJECT_NAME is not set before project() we are the main project.
if(NOT PROJECT_NAME)
    message(STATUS "[SDKlib] is a top-level project. Install target is enabled by default.")
    set(SDKLIB_STANDALONE 1)
    if (CMAKE_SYSTEM_NAME STREQUAL "iOS")
        message(STATUS "Examples and tests will not be enabled by default.")
        option(ENABLE_SDKLIB_EXAMPLES "Example application is built if enabled" OFF)
        option(ENABLE_SDKLIB_TESTS "Integration and unit tests are built if enabled" OFF)
    else()
        message(STATUS "Examples and tests will be enabled by default.")
        option(ENABLE_SDKLIB_EXAMPLES "Example application is built if enabled" ON)
        option(ENABLE_SDKLIB_TESTS "Integration and unit tests are built if enabled" ON)
    endif()
    if (WIN32)
        option(ENABLE_SDKLIB_WERROR "Enable warnings as errors" ON)
    else()
        option(ENABLE_SDKLIB_WERROR "Enable warnings as errors when building in debug mode." OFF)
    endif()
else()
    message(STATUS "[SDKlib] is building under project [${PROJECT_NAME}] Install target, examples and tests will not be enabled by default.")
    set(SDKLIB_STANDALONE 0)
    option(ENABLE_SDKLIB_EXAMPLES "Example application is built if enabled" OFF)
    option(ENABLE_SDKLIB_TESTS "Integration and unit tests are built if enabled" OFF)
    option(ENABLE_SDKLIB_WERROR "Enable warnings as errors." OFF)
endif()

## General configuration

include(sdklib_variables)

if(NOT PROJECT_NAME)
    if(VCPKG_ROOT)
        # Include VCPKG management tools.
        include(vcpkg_management)
        process_vcpkg_libraries(${CMAKE_CURRENT_LIST_DIR}/cmake)
    else()
        # For packages with no pkg-config in the system.
        list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/cmake/modules/packages)
        message(STATUS "Using system dependencies")
    endif()
endif()

# Get SDK library version to use it as the CMake project version.
include(load_sdk_version)
read_sdk_version(MEGA_SDK_VERSION ${CMAKE_CURRENT_LIST_DIR}/include/mega/version.h)

project(SDKlib
    VERSION ${MEGA_SDK_VERSION}
    DESCRIPTION "MEGA SDK Library"
    )

# In-source build not allowed
if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
    message(FATAL_ERROR "In-source build is not allowed. Remove CMakeCache.txt and the CMakeFiles directory and set a new binary directory different than the source tree.")
endif()

message(STATUS "Generator: ${CMAKE_GENERATOR}")
if(CMAKE_GENERATOR_PLATFORM)
    message(STATUS "Platform: ${CMAKE_GENERATOR_PLATFORM}")
endif()
if(APPLE)
    if(CMAKE_OSX_ARCHITECTURES)
        message(STATUS "Architectures: ${CMAKE_OSX_ARCHITECTURES}")
    else()
        message(STATUS "Architectures: -Not set- (It defaults to the host system architecture)")
    endif()
    message(STATUS "Minimum deployment version: ${CMAKE_OSX_DEPLOYMENT_TARGET}")
endif()
message(STATUS "Target System Processor: ${CMAKE_SYSTEM_PROCESSOR}")
message(STATUS "Host System Processor: ${CMAKE_HOST_SYSTEM_PROCESSOR}")

get_property(IS_MULTI_CONFIG GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)

if(IS_MULTI_CONFIG)
    if(CMAKE_CONFIGURATION_TYPES)
        message(STATUS "Generated with config types: ${CMAKE_CONFIGURATION_TYPES}")
    else()
        message(FATAL_ERROR "You must specify CMAKE_CONFIGURATION_TYPES")
    endif()
else()
    if(CMAKE_BUILD_TYPE)
        message(STATUS "Build type set to: ${CMAKE_BUILD_TYPE}")
    else()
        message(FATAL_ERROR "You must specify CMAKE_BUILD_TYPE. For example: -DCMAKE_BUILD_TYPE=Debug")
    endif()
endif()

if($ENV{CFLAGS})
    message(STATUS "Environment CFLAGS: $ENV{CFLAGS}")
endif()
if($ENV{CXXFLAGS})
    message(STATUS "Environment CXXFLAGS: $ENV{CXXFLAGS}")
endif()
if($ENV{LDFLAGS})
    message(STATUS "Environment LDFLAGS: $ENV{LDFLAGS}")
endif()

if(USE_READLINE AND WIN32)
    message(FATAL_ERROR "Readline is not available in Windows builds. Disable USE_READLINE to continue.")
endif()

if(ENABLE_ISOLATED_GFX AND NOT USE_FREEIMAGE)
    message(FATAL_ERROR "USE_FREEIMAGE is required when ENABLE_ISOLATED_GFX is enabled.")
endif()

message(STATUS "Building SDKlib v${PROJECT_VERSION}")

include(GNUInstallDirs) # Values for installation directories. All platforms
include(CMakePackageConfigHelpers) # For the CMake package
include(target_sources_conditional) # To add files to the project without building them
include(target_platform_compile_options) # To add compile options depeding on the platform
include(sdklib_libraries) # Includes a macro to load the dependencies, both the VCPKG or the system ones.

# Load common and per platform configuration for the project
include(configuration)

## Start loading targets
include(sdklib_target)

# Load Qt bindings
if(ENABLE_QT_BINDINGS)
    add_subdirectory(bindings/qt)
endif()

# Load Java bindings
if(ENABLE_JAVA_BINDINGS)
    add_subdirectory(bindings/java)
endif()

if(ENABLE_ISOLATED_GFX)
    add_subdirectory(tools/gfxworker)
endif()

## Load examples and tests
if(ENABLE_SDKLIB_EXAMPLES)
    add_subdirectory(examples)
endif()

if(ENABLE_SDKLIB_TESTS)
    add_subdirectory(tests)
endif()

## Load FUSE support.
include(src/fuse/CMakeLists.txt)

=== automation/requirements.txt ===
jira
python-gitlab
slack_sdk
github3.py
atlassian-python-api

=== tests/CMakeLists.txt ===
# Common interface target for test tools
add_library(test_tools STATIC)
add_library(MEGA::test_tools ALIAS test_tools)

target_sources(test_tools
    PRIVATE
    gtest_common.h
    sdk_test_utils.h
    stdfs.h

    gtest_common.cpp
    sdk_test_utils.cpp
)

target_link_libraries(test_tools PRIVATE MEGA::SDKlib)

target_include_directories(test_tools
    PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}
)

# Common interface target for configurations and libraries for the SDK and MEGAchat tests.
add_library(test_common INTERFACE)
add_library(MEGA::test_common ALIAS test_common)

# Look for the libraries needed for both unit tests and integration tests for the SDK and MEGAchat.
if(VCPKG_ROOT)
    find_package(GTest CONFIG REQUIRED)
    target_link_libraries(test_common INTERFACE GTest::gmock GTest::gtest)
else()
    pkg_check_modules(gtest REQUIRED IMPORTED_TARGET gtest)
    pkg_check_modules(gmock REQUIRED IMPORTED_TARGET gmock)
    target_link_libraries(test_common INTERFACE PkgConfig::gmock PkgConfig::gtest)
endif()

if(ENABLE_SDKLIB_TESTS) # This file is also loaded for MEGAchat tests.
    add_subdirectory(integration)
    add_subdirectory(unit)
endif()

=== bindings/java/CMakeLists.txt ===
find_package(Java REQUIRED)
find_package(SWIG REQUIRED)
include(UseSWIG)

# Set the output directory for generated Java files
set(JAVA_OUTPUT_DIR ${CMAKE_BINARY_DIR}/bindings/java/nz/mega/sdk)

# Define the interface file and its properties
set(SWIG_INTERFACE_FILE ${CMAKE_CURRENT_LIST_DIR}/../megaapi.i)
set_source_files_properties(${SWIG_INTERFACE_FILE} PROPERTIES
    CPLUSPLUS ON
)

# Set SWIG flags for generating Java code
if(ENABLE_SYNC)
    list(APPEND ADDITIONAL_SWIG_DEFINES -DENABLE_SYNC)
endif()

if(USE_LIBUV)
    list(APPEND ADDITIONAL_SWIG_DEFINES -DHAVE_LIBUV)
endif()

set(CMAKE_SWIG_FLAGS -c++ -package "nz.mega.sdk" ${ADDITIONAL_SWIG_DEFINES} -I${CMAKE_CURRENT_LIST_DIR}/../../include)

# Generate java binding files
swig_add_library(SDKJavaBindings
    LANGUAGE java
    SOURCES ${SWIG_INTERFACE_FILE}
    OUTPUT_DIR ${JAVA_OUTPUT_DIR}
)

# For Android we do not need JNI
if(ANDROID)
    set(JNI_INCLUDE_DIRS
        ${ANDROID_NDK_HOME}/sysroot/usr/include
        ${ANDROID_NDK_HOME}/sysroot/usr/include/${ANDROID_ABI}
    )
else()
    find_package(JNI REQUIRED)
endif()

target_include_directories(SDKJavaBindings
    PRIVATE
    ${Java_INCLUDE_DIRS}
    ${JNI_INCLUDE_DIRS}
    ${JAVA_OUTPUT_DIR}
)

target_link_libraries(SDKJavaBindings
    PRIVATE
    MEGA::SDKlib
)

# Compile Java code
add_custom_command(TARGET SDKJavaBindings POST_BUILD
    COMMAND ${Java_JAVAC_EXECUTABLE} -d ${JAVA_OUTPUT_DIR} -cp ${JAVA_OUTPUT_DIR} ${JAVA_OUTPUT_DIR}/*.java
    COMMENT "Compiling Java classes..."
)

=== tests/integration/CMakeLists.txt ===
add_executable(test_integration)

target_sources(test_integration
    PRIVATE
    env_var_accounts.h
    SdkTest_test.h
    SdkTestNodesSetUp_test.h
    test.h
    integration_test_utils.h
    mock_listeners.h

    env_var_accounts.cpp
    main.cpp
    SdkTest_test.cpp
    SdkTestNodesSetUp_test.cpp
    SdkTestFilter_test.cpp
    SdkTestPasswordManager_test.cpp
    SdkTestCreateAccount_test.cpp
    SdkTestTransferStats_test.cpp
    sdk_test_user_attributes.cpp
    SdkTestSyncNodeOperations_test.cpp
    SdkTestChangeLocalSyncRoot_test.cpp
    Sync_test.cpp
    one_question_survey_test.cpp
    share_test.cpp
    integration_test_utils.cpp
    DisableBackupSync_test.cpp
)

target_sources_conditional(test_integration
    FLAG ENABLE_ISOLATED_GFX
    PRIVATE
    IsolatedGfx_test.cpp
)

# Link with SDKlib
target_link_libraries(test_integration PRIVATE MEGA::SDKlib)

# Link with the common and tools interface libraries for the tests.
target_link_libraries(test_integration
    PRIVATE
    MEGA::test_tools
    MEGA::test_common
)

# Adjust compilation flags for warnings and errors
target_platform_compile_options(
    TARGET test_integration
    WINDOWS /bigobj /we4800 # Implicit conversion from 'type' to bool. Possible information loss
    UNIX $<$<CONFIG:Debug>:-ggdb3> -Wall -Wextra -Wconversion
)

if(ENABLE_SDKLIB_WERROR)
    target_platform_compile_options(
        TARGET test_integration
        WINDOWS /WX
        UNIX  $<$<CONFIG:Debug>: -Werror>
    )
endif()

# Integration tests require the following files to work
file(GLOB TESTING_AUX_FILES "test-data/*")
add_custom_command(
    TARGET test_integration POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy ${TESTING_AUX_FILES} $<TARGET_FILE_DIR:test_integration>
    COMMENT "Copying test files for integration tests."
)

if(TARGET gfxworker)
    add_custom_command(
        TARGET test_integration POST_BUILD
        COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_FILE:gfxworker> $<TARGET_FILE_DIR:test_integration>
        COMMENT "Copying gfxworker for integration tests."
    )
endif()

=== tests/unit/CMakeLists.txt ===
add_executable(test_unit)

target_sources(test_unit
    PRIVATE
    constants.h
    DefaultedDbTable.h
    DefaultedDirAccess.h
    DefaultedFileAccess.h
    DefaultedFileSystemAccess.h
    FsNode.h
    NotImplemented.h
    utils.h

    main.cpp
    Arguments_test.cpp
    AttrMap_test.cpp
    CacheLRU_test.cpp
    ChunkMacMap_test.cpp
    Commands_test.cpp
    Crypto_test.cpp
    FileFingerprint_test.cpp
    File_test.cpp
    FsNode.cpp
    hashcash_test.cpp
    Logging_test.cpp
    MediaProperties_test.cpp
    MegaApi_test.cpp
    name_collision_test.cpp
    PayCrypter_test.cpp
    PendingContactRequest_test.cpp
    Scoped_timer_test.cpp
    Serialization_test.cpp
    Share_test.cpp
    Sync_conflict_test.cpp
    Sync_test.cpp
    TextChat_test.cpp
    Transfer_test.cpp
    Transferstats_test.cpp
    User_test.cpp
    user_attributes_test.cpp
    impl/share_test.cpp
    utils.cpp
    utils_test.cpp
    pwm_file_parser_test.cpp
    pwm_import_validation.cpp
)

target_sources_conditional(test_unit
    FLAG ENABLE_ISOLATED_GFX
    PRIVATE
    Isolatedprocess_test.cpp
    GfxCommands_test.cpp
)

# Link with SDKlib
target_link_libraries(test_unit PRIVATE MEGA::SDKlib)

# Link with the common interface library for the tests.
target_link_libraries(test_unit PRIVATE MEGA::test_tools MEGA::test_common)

# Adjust compilation flags for warnings and errors
target_platform_compile_options(
    TARGET test_unit
    WINDOWS /we4800 # Implicit conversion from 'type' to bool. Possible information loss
    UNIX $<$<CONFIG:Debug>:-ggdb3> -Wall -Wextra -Wconversion
)

if(ENABLE_SDKLIB_WERROR)
    target_platform_compile_options(
        TARGET test_unit
        WINDOWS /WX
        UNIX  $<$<CONFIG:Debug>: -Werror>
    )
endif()

=== cmake/vcpkg_overlay_ports/jxrlib/CMakeLists.txt ===
# Copyright Mathieu Malaterre <malat@debian.org>
# BSD (Same as jxrlib)
# Based on https://jxrlib.codeplex.com/discussions/440294
# and modified for vcpkg packaging
cmake_minimum_required(VERSION 2.8)
project(jxrlib C)

# Need shared libs for ABI
option(BUILD_SHARED_LIBS "Build shared libraries" ON)

# Add a debug postfix
set(CMAKE_DEBUG_POSTFIX "d")

# helper macro to preserve original Makefile convention
macro(JXR_MAKE_OBJ SET_NAME)
  foreach(src ${SRC_${SET_NAME}})
    list(APPEND OBJ_${SET_NAME} ${DIR_${SET_NAME}}/${src})
  endforeach()
endmacro()

if(NOT WIN32)
  add_definitions(-D__ANSI__)
endif()
if(NOT MSVC)
  add_compile_options(-Wno-error=implicit-function-declaration -Wno-endif-labels)
endif()

include(TestBigEndian)
test_big_endian(ISBIGENDIAN)
if(ISBIGENDIAN)
  set(DEF_ENDIAN _BIG__ENDIAN_)
endif()

set(DIR_SYS image/sys)
set(DIR_DEC image/decode)
set(DIR_ENC image/encode)

set(DIR_GLUE jxrgluelib)
set(DIR_TEST jxrtestlib)
set(DIR_EXEC jxrencoderdecoder)

if(NOT JXRLIB_INSTALL_BIN_DIR)
  set(JXRLIB_INSTALL_BIN_DIR "bin")
endif()

if(NOT JXRLIB_INSTALL_LIB_DIR)
  set(JXRLIB_INSTALL_LIB_DIR "lib")
endif()

if(NOT JXRLIB_INSTALL_INCLUDE_DIR)
  set(JXRLIB_INSTALL_INCLUDE_DIR "include/jxrlib")
endif()

include_directories(
  common/include
  ${DIR_SYS}
  ${DIR_GLUE}
  ${DIR_TEST}
)


# JPEG-XR
set(SRC_SYS adapthuff.c image.c strcodec.c strPredQuant.c strTransform.c perfTimerANSI.c)
JXR_MAKE_OBJ(SYS)
set(SRC_DEC decode.c postprocess.c segdec.c strdec.c strInvTransform.c strPredQuantDec.c JXRTranscode.c)
JXR_MAKE_OBJ(DEC)
set(SRC_ENC encode.c segenc.c strenc.c strFwdTransform.c strPredQuantEnc.c)
JXR_MAKE_OBJ(ENC)

add_library(jpegxr ${OBJ_ENC} ${OBJ_DEC} ${OBJ_SYS})
set_property(TARGET jpegxr
  PROPERTY COMPILE_DEFINITIONS DISABLE_PERF_MEASUREMENT ${DEF_ENDIAN}
)
set_property(TARGET jpegxr PROPERTY LINK_INTERFACE_LIBRARIES "")
install(TARGETS jpegxr
  EXPORT JXRLibTargets
  RUNTIME DESTINATION ${JXRLIB_INSTALL_BIN_DIR}
  LIBRARY DESTINATION ${JXRLIB_INSTALL_LIB_DIR}
  ARCHIVE DESTINATION ${JXRLIB_INSTALL_LIB_DIR}
)

# JXR-GLUE
set(SRC_GLUE JXRGlue.c JXRMeta.c JXRGluePFC.c JXRGlueJxr.c)
JXR_MAKE_OBJ(GLUE)
set(SRC_TEST JXRTest.c JXRTestBmp.c JXRTestHdr.c JXRTestPnm.c JXRTestTif.c JXRTestYUV.c)
JXR_MAKE_OBJ(TEST)

add_library(jxrglue ${OBJ_GLUE} ${OBJ_TEST})
set_property(TARGET jxrglue
  PROPERTY COMPILE_DEFINITIONS DISABLE_PERF_MEASUREMENT ${DEF_ENDIAN}
)
set_property(TARGET jxrglue PROPERTY LINK_INTERFACE_LIBRARIES "")
install(TARGETS jxrglue
  EXPORT JXRLibTargets
  RUNTIME DESTINATION ${JXRLIB_INSTALL_BIN_DIR}
  LIBRARY DESTINATION ${JXRLIB_INSTALL_LIB_DIR}
  ARCHIVE DESTINATION ${JXRLIB_INSTALL_LIB_DIR}
)

target_link_libraries(jxrglue jpegxr)

# install rules
install(FILES jxrgluelib/JXRGlue.h jxrgluelib/JXRMeta.h jxrtestlib/JXRTest.h
  image/sys/windowsmediaphoto.h
  DESTINATION ${JXRLIB_INSTALL_INCLUDE_DIR} COMPONENT Headers
)
install(DIRECTORY common/include/ DESTINATION ${JXRLIB_INSTALL_INCLUDE_DIR}
  FILES_MATCHING PATTERN "*.h"
)

=== src/fuse/common/CMakeLists.txt ===
# Convenience
set(FUSE_COMMON_SRC ${CMAKE_CURRENT_LIST_DIR})
set(FUSE_COMMON_INC ${FUSE_COMMON_SRC}/../../../include/mega/fuse/common)

# Let the SDK know where it can find our headers.
target_include_directories(
    ${SDK_TARGET} PUBLIC $<BUILD_INTERFACE:${FUSE_COMMON_SRC}>)

# Add sources required by all backends.
target_sources(${SDK_TARGET} PRIVATE
                             ${FUSE_COMMON_INC}/activity_monitor.h
                             ${FUSE_COMMON_INC}/activity_monitor_forward.h
                             ${FUSE_COMMON_INC}/any_lock.h
                             ${FUSE_COMMON_INC}/any_lock_forward.h
                             ${FUSE_COMMON_INC}/any_lock_set.h
                             ${FUSE_COMMON_INC}/any_lock_set_forward.h
                             ${FUSE_COMMON_INC}/bind_handle.h
                             ${FUSE_COMMON_INC}/bind_handle_forward.h
                             ${FUSE_COMMON_INC}/client.h
                             ${FUSE_COMMON_INC}/client_adapter.h
                             ${FUSE_COMMON_INC}/client_callbacks.h
                             ${FUSE_COMMON_INC}/client_forward.h
                             ${FUSE_COMMON_INC}/database.h
                             ${FUSE_COMMON_INC}/date_time.h
                             ${FUSE_COMMON_INC}/date_time_forward.h
                             ${FUSE_COMMON_INC}/error_or.h
                             ${FUSE_COMMON_INC}/error_or_forward.h
                             ${FUSE_COMMON_INC}/file_open_flag.h
                             ${FUSE_COMMON_INC}/file_open_flag_forward.h
                             ${FUSE_COMMON_INC}/inode_cache_flags.h
                             ${FUSE_COMMON_INC}/inode_cache_flags_forward.h
                             ${FUSE_COMMON_INC}/inode_id.h
                             ${FUSE_COMMON_INC}/inode_id_forward.h
                             ${FUSE_COMMON_INC}/inode_info.h
                             ${FUSE_COMMON_INC}/inode_info_forward.h
                             ${FUSE_COMMON_INC}/lock.h
                             ${FUSE_COMMON_INC}/lock_forward.h
                             ${FUSE_COMMON_INC}/lockable.h
                             ${FUSE_COMMON_INC}/lockable_forward.h
                             ${FUSE_COMMON_INC}/log_level.h
                             ${FUSE_COMMON_INC}/log_level_forward.h
                             ${FUSE_COMMON_INC}/logger.h
                             ${FUSE_COMMON_INC}/logger_forward.h
                             ${FUSE_COMMON_INC}/logging.h
                             ${FUSE_COMMON_INC}/mount_event.h
                             ${FUSE_COMMON_INC}/mount_event_forward.h
                             ${FUSE_COMMON_INC}/mount_event_type.h
                             ${FUSE_COMMON_INC}/mount_event_type_forward.h
                             ${FUSE_COMMON_INC}/mount_flags.h
                             ${FUSE_COMMON_INC}/mount_flags_forward.h
                             ${FUSE_COMMON_INC}/mount_info.h
                             ${FUSE_COMMON_INC}/mount_info_forward.h
                             ${FUSE_COMMON_INC}/mount_inode_id.h
                             ${FUSE_COMMON_INC}/mount_inode_id_forward.h
                             ${FUSE_COMMON_INC}/mount_result.h
                             ${FUSE_COMMON_INC}/mount_result_forward.h
                             ${FUSE_COMMON_INC}/node_event.h
                             ${FUSE_COMMON_INC}/node_event_forward.h
                             ${FUSE_COMMON_INC}/node_event_observer.h
                             ${FUSE_COMMON_INC}/node_event_observer_forward.h
                             ${FUSE_COMMON_INC}/node_event_queue.h
                             ${FUSE_COMMON_INC}/node_event_queue_forward.h
                             ${FUSE_COMMON_INC}/node_event_type.h
                             ${FUSE_COMMON_INC}/node_event_type_forward.h
                             ${FUSE_COMMON_INC}/node_info.h
                             ${FUSE_COMMON_INC}/node_info_forward.h
                             ${FUSE_COMMON_INC}/normalized_path.h
                             ${FUSE_COMMON_INC}/normalized_path_forward.h
                             ${FUSE_COMMON_INC}/pending_callbacks.h
                             ${FUSE_COMMON_INC}/query.h
                             ${FUSE_COMMON_INC}/query_forward.h
                             ${FUSE_COMMON_INC}/scoped_query.h
                             ${FUSE_COMMON_INC}/scoped_query_forward.h
                             ${FUSE_COMMON_INC}/service.h
                             ${FUSE_COMMON_INC}/service_callbacks.h
                             ${FUSE_COMMON_INC}/service_context.h
                             ${FUSE_COMMON_INC}/service_context_forward.h
                             ${FUSE_COMMON_INC}/service_flags.h
                             ${FUSE_COMMON_INC}/service_flags_forward.h
                             ${FUSE_COMMON_INC}/service_forward.h
                             ${FUSE_COMMON_INC}/shared_mutex.h
                             ${FUSE_COMMON_INC}/shared_mutex_forward.h
                             ${FUSE_COMMON_INC}/task_executor.h
                             ${FUSE_COMMON_INC}/task_executor_flags.h
                             ${FUSE_COMMON_INC}/task_executor_flags_forward.h
                             ${FUSE_COMMON_INC}/task_executor_forward.h
                             ${FUSE_COMMON_INC}/task_queue.h
                             ${FUSE_COMMON_INC}/task_queue_forward.h
                             ${FUSE_COMMON_INC}/transaction.h
                             ${FUSE_COMMON_INC}/transaction_forward.h
                             ${FUSE_COMMON_INC}/type_traits.h
                             ${FUSE_COMMON_INC}/upload.h
                             ${FUSE_COMMON_INC}/upload_callbacks.h
                             ${FUSE_COMMON_INC}/upload_forward.h
                             ${FUSE_COMMON_INC}/utility.h
                             ${FUSE_COMMON_SRC}/activity_monitor.cpp
                             ${FUSE_COMMON_SRC}/any_lock_set.cpp
                             ${FUSE_COMMON_SRC}/bind_handle.cpp
                             ${FUSE_COMMON_SRC}/client.cpp
                             ${FUSE_COMMON_SRC}/client_adapter.cpp
                             ${FUSE_COMMON_SRC}/database.cpp
                             ${FUSE_COMMON_SRC}/date_time.cpp
                             ${FUSE_COMMON_SRC}/inode_id.cpp
                             ${FUSE_COMMON_SRC}/inode_info.cpp
                             ${FUSE_COMMON_SRC}/log_level.cpp
                             ${FUSE_COMMON_SRC}/logger.cpp
                             ${FUSE_COMMON_SRC}/mount_event.cpp
                             ${FUSE_COMMON_SRC}/mount_event_type.cpp
                             ${FUSE_COMMON_SRC}/mount_flags.cpp
                             ${FUSE_COMMON_SRC}/mount_info.cpp
                             ${FUSE_COMMON_SRC}/mount_inode_id.cpp
                             ${FUSE_COMMON_SRC}/mount_result.cpp
                             ${FUSE_COMMON_SRC}/node_event_type.cpp
                             ${FUSE_COMMON_SRC}/normalized_path.cpp
                             ${FUSE_COMMON_SRC}/pending_callbacks.cpp
                             ${FUSE_COMMON_SRC}/query.cpp
                             ${FUSE_COMMON_SRC}/scoped_query.cpp
                             ${FUSE_COMMON_SRC}/service.cpp
                             ${FUSE_COMMON_SRC}/service_context.cpp
                             ${FUSE_COMMON_SRC}/shared_mutex.cpp
                             ${FUSE_COMMON_SRC}/task_executor.cpp
                             ${FUSE_COMMON_SRC}/task_queue.cpp
                             ${FUSE_COMMON_SRC}/transaction.cpp
                             ${FUSE_COMMON_SRC}/upload.cpp
                             ${FUSE_COMMON_SRC}/utility.cpp
)

# Assume the sync engine is being built.
set(TEMP "with")

# The sync engine isn't being built.
if (NOT ENABLE_SYNC)
    string(APPEND TEMP "out")
endif()

# Compute path to sync-engine-dependent client-adapter code.
set(TEMP "${FUSE_COMMON_SRC}/client_adapter_${TEMP}_sync.cpp")

# Make sure code is built into the SDK.
target_sources(${SDK_TARGET} PRIVATE ${TEMP})

# Clean up after ourselves.
unset(TEMP)

# Not building with FUSE support.
if (NOT WITH_FUSE)
    return()
endif()

# Add sources required by concrete backends.
target_sources(${SDK_TARGET} PRIVATE
                             ${FUSE_COMMON_INC}/badge.h
                             ${FUSE_COMMON_INC}/badge_forward.h
                             ${FUSE_COMMON_INC}/constants.h
                             ${FUSE_COMMON_INC}/database_builder.h
                             ${FUSE_COMMON_INC}/database_forward.h
                             ${FUSE_COMMON_INC}/directory_inode.h
                             ${FUSE_COMMON_INC}/directory_inode_forward.h
                             ${FUSE_COMMON_INC}/directory_inode_results.h
                             ${FUSE_COMMON_INC}/error_or.h
                             ${FUSE_COMMON_INC}/error_or_forward.h
                             ${FUSE_COMMON_INC}/file_cache.h
                             ${FUSE_COMMON_INC}/file_cache_forward.h
                             ${FUSE_COMMON_INC}/file_extension_db.h
                             ${FUSE_COMMON_INC}/file_extension_db_forward.h
                             ${FUSE_COMMON_INC}/file_info.h
                             ${FUSE_COMMON_INC}/file_info_forward.h
                             ${FUSE_COMMON_INC}/file_inode.h
                             ${FUSE_COMMON_INC}/file_inode_forward.h
                             ${FUSE_COMMON_INC}/file_io_context.h
                             ${FUSE_COMMON_INC}/file_io_context_forward.h
                             ${FUSE_COMMON_INC}/inode.h
                             ${FUSE_COMMON_INC}/inode_badge.h
                             ${FUSE_COMMON_INC}/inode_badge_forward.h
                             ${FUSE_COMMON_INC}/inode_cache.h
                             ${FUSE_COMMON_INC}/inode_cache_forward.h
                             ${FUSE_COMMON_INC}/inode_db.h
                             ${FUSE_COMMON_INC}/inode_db_forward.h
                             ${FUSE_COMMON_INC}/inode_forward.h
                             ${FUSE_COMMON_INC}/mount.h
                             ${FUSE_COMMON_INC}/mount_db.h
                             ${FUSE_COMMON_INC}/mount_db_forward.h
                             ${FUSE_COMMON_INC}/mount_forward.h
                             ${FUSE_COMMON_INC}/path_adapter.h
                             ${FUSE_COMMON_INC}/path_adapter_forward.h
                             ${FUSE_COMMON_INC}/ref.h
                             ${FUSE_COMMON_INC}/ref_forward.h
                             ${FUSE_COMMON_INC}/tags.h
                             ${FUSE_COMMON_SRC}/database_builder.cpp
                             ${FUSE_COMMON_SRC}/directory_inode.cpp
                             ${FUSE_COMMON_SRC}/file_cache.cpp
                             ${FUSE_COMMON_SRC}/file_extension_db.cpp
                             ${FUSE_COMMON_SRC}/file_info.cpp
                             ${FUSE_COMMON_SRC}/file_inode.cpp
                             ${FUSE_COMMON_SRC}/file_io_context.cpp
                             ${FUSE_COMMON_SRC}/inode.cpp
                             ${FUSE_COMMON_SRC}/inode_cache.cpp
                             ${FUSE_COMMON_SRC}/inode_db.cpp
                             ${FUSE_COMMON_SRC}/mount.cpp
                             ${FUSE_COMMON_SRC}/mount_db.cpp
)

# Are we building integration tests?
if (NOT TARGET test_integration)
    return()
endif()

set(FUSE_COMMON_TESTING_INC ${FUSE_COMMON_SRC}/mega/fuse/common/testing)
set(FUSE_COMMON_TESTING_SRC ${FUSE_COMMON_SRC}/testing)

# Assume we're not building using the legacy scripts.
set(SDK_SOURCE_DIR ${PROJECT_SOURCE_DIR})

# We are building using the legacy scripts.
if (TARGET Mega)

=== src/fuse/unsupported/CMakeLists.txt ===
# Convenience.
set(FUSE_UNSUPPORTED_SRC ${CMAKE_CURRENT_LIST_DIR})
set(FUSE_UNSUPPORTED_INC ${FUSE_UNSUPPORTED_SRC}/mega/fuse/platform)

# Let the SDK know where it can find our headers.
target_include_directories(${SDK_TARGET} PRIVATE ${FUSE_UNSUPPORTED_SRC})

# Add sources required by dummy backend.
target_sources(${SDK_TARGET} PRIVATE
                             ${FUSE_UNSUPPORTED_INC}/service_context.h
                             ${FUSE_UNSUPPORTED_SRC}/service_context.cpp
                             ${FUSE_UNSUPPORTED_SRC}/service.cpp
)

=== src/fuse/supported/posix/CMakeLists.txt ===
# Convenience.
set(FUSE_POSIX_SRC ${CMAKE_CURRENT_LIST_DIR})
set(FUSE_POSIX_INC ${FUSE_POSIX_SRC}/mega/fuse/platform)

# Let CMake know where it can find our FindFUSE module.
list(APPEND CMAKE_MODULE_PATH ${FUSE_POSIX_SRC}/cmake)

# Make sure libfuse is present.
find_package(FUSE REQUIRED)

# Make sure the SDKs linked against libfuse.
target_link_libraries(${SDK_TARGET} PRIVATE FUSE)

# Let the SDK know where it can find our headers.
target_include_directories(${SDK_TARGET} PRIVATE ${FUSE_POSIX_SRC})

# Add sources required by libfuse backend.
target_sources(${SDK_TARGET} PRIVATE
                             ${FUSE_POSIX_INC}/constants.h
                             ${FUSE_POSIX_INC}/directory_context.h
                             ${FUSE_POSIX_INC}/file_descriptor.h
                             ${FUSE_POSIX_INC}/file_descriptor_forward.h
                             ${FUSE_POSIX_INC}/inode_invalidator.h
                             ${FUSE_POSIX_INC}/library.h
                             ${FUSE_POSIX_INC}/mount.h
                             ${FUSE_POSIX_INC}/mount_db.h
                             ${FUSE_POSIX_INC}/path_adapter.h
                             ${FUSE_POSIX_INC}/process.h
                             ${FUSE_POSIX_INC}/process_forward.h
                             ${FUSE_POSIX_INC}/request.h
                             ${FUSE_POSIX_INC}/request_forward.h
                             ${FUSE_POSIX_INC}/session.h
                             ${FUSE_POSIX_INC}/session_forward.h
                             ${FUSE_POSIX_INC}/signal.h
                             ${FUSE_POSIX_INC}/utility.h
                             ${FUSE_POSIX_SRC}/constants.cpp
                             ${FUSE_POSIX_SRC}/directory_context.cpp
                             ${FUSE_POSIX_SRC}/file_descriptor.cpp
                             ${FUSE_POSIX_SRC}/inode_invalidator.cpp
                             ${FUSE_POSIX_SRC}/mount.cpp
                             ${FUSE_POSIX_SRC}/mount_db.cpp
                             ${FUSE_POSIX_SRC}/process.cpp
                             ${FUSE_POSIX_SRC}/request.cpp
                             ${FUSE_POSIX_SRC}/service.cpp
                             ${FUSE_POSIX_SRC}/session.cpp
                             ${FUSE_POSIX_SRC}/signal.cpp
                             ${FUSE_POSIX_SRC}/unmounter.cpp
                             ${FUSE_POSIX_SRC}/utility.cpp
)

# What kind of UNIX are we building for?
string(TOLOWER ${CMAKE_SYSTEM_NAME} FUSE_UNIX_TYPE)

# Where can we find UNIX-specific sources?
set(FUSE_UNIX_SRC ${FUSE_POSIX_SRC}/${FUSE_UNIX_TYPE})
set(FUSE_UNIX_INC ${FUSE_UNIX_SRC}/mega/fuse/platform)

# Add UNIX-specific sources.
target_sources(${SDK_TARGET} PRIVATE
                             ${FUSE_UNIX_INC}/date_time.h
                             ${FUSE_UNIX_INC}/platform.h
                             ${FUSE_UNIX_SRC}/utility.cpp
)

target_include_directories(${SDK_TARGET} PRIVATE ${FUSE_UNIX_SRC})

# Are we building integration tests?
if (NOT TARGET test_integration)
    return()
endif()

set(FUSE_POSIX_TESTING_SRC ${FUSE_POSIX_SRC}/testing)
set(FUSE_POSIX_TESTING_INC ${FUSE_POSIX_INC}/testing)

set(FUSE_UNIX_TESTING_INC ${FUSE_UNIX_INC}/testing)
set(FUSE_UNIX_TESTING_SRC ${FUSE_UNIX_SRC}/testing)

target_include_directories(test_integration PRIVATE
                                            ${FUSE_POSIX_SRC}
                                            ${FUSE_UNIX_SRC}
)

target_sources(test_integration PRIVATE
                                ${FUSE_POSIX_TESTING_INC}/printers.h
                                ${FUSE_POSIX_TESTING_INC}/wrappers.h
                                ${FUSE_POSIX_TESTING_SRC}/mount_tests.cpp
                                ${FUSE_POSIX_TESTING_SRC}/platform_tests.cpp
                                ${FUSE_POSIX_TESTING_SRC}/printers.cpp
                                ${FUSE_POSIX_TESTING_SRC}/utility.cpp
                                ${FUSE_POSIX_TESTING_SRC}/wrappers.cpp
)

if (EXISTS ${FUSE_UNIX_SRC}/platform_tests.cpp)
    target_sources(test_integration PRIVATE
                                    ${FUSE_UNIX_SRC}/platform_tests.cpp
    )
endif()

=== src/fuse/supported/windows/CMakeLists.txt ===
# Convenience.
set(FUSE_WINDOWS_SRC ${CMAKE_CURRENT_LIST_DIR})
set(FUSE_WINDOWS_INC ${FUSE_WINDOWS_SRC}/mega/fuse/platform)

# Let CMake know where it can find our FindWinFsP module.
list(APPEND CMAKE_MODULE_PATH ${FUSE_WINDOWS_SRC}/cmake)

# Make sure WinFSP is present.
find_package(WinFSP REQUIRED)

# Make sure the SDK links against WinFSP.
target_link_libraries(${SDK_TARGET} PUBLIC WinFSP)

# Let the SDK know where it can find our headers.
target_include_directories(${SDK_TARGET} PRIVATE ${FUSE_WINDOWS_SRC})

# Add sources required by WinFSP backend.
target_sources(${SDK_TARGET} PRIVATE
                             ${FUSE_WINDOWS_INC}/constants.h
                             ${FUSE_WINDOWS_INC}/date_time.h
                             ${FUSE_WINDOWS_INC}/directory_context.h
                             ${FUSE_WINDOWS_INC}/dispatcher.h
                             ${FUSE_WINDOWS_INC}/dispatcher_forward.h
                             ${FUSE_WINDOWS_INC}/handle.h
                             ${FUSE_WINDOWS_INC}/handle_forward.h
                             ${FUSE_WINDOWS_INC}/library.h
                             ${FUSE_WINDOWS_INC}/local_pointer.h
                             ${FUSE_WINDOWS_INC}/mount.h
                             ${FUSE_WINDOWS_INC}/mount_db.h
                             ${FUSE_WINDOWS_INC}/path_adapter.h
                             ${FUSE_WINDOWS_INC}/platform.h
                             ${FUSE_WINDOWS_INC}/security_descriptor.h
                             ${FUSE_WINDOWS_INC}/security_descriptor_forward.h
                             ${FUSE_WINDOWS_INC}/security_identifier.h
                             ${FUSE_WINDOWS_INC}/security_identifier_forward.h
                             ${FUSE_WINDOWS_INC}/utility.h
                             ${FUSE_WINDOWS_INC}/windows.h
                             ${FUSE_WINDOWS_SRC}/constants.cpp
                             ${FUSE_WINDOWS_SRC}/directory_context.cpp
                             ${FUSE_WINDOWS_SRC}/dispatcher.cpp
                             ${FUSE_WINDOWS_SRC}/local_pointer.cpp
                             ${FUSE_WINDOWS_SRC}/mount.cpp
                             ${FUSE_WINDOWS_SRC}/mount_db.cpp
                             ${FUSE_WINDOWS_SRC}/security_descriptor.cpp
                             ${FUSE_WINDOWS_SRC}/security_identifier.cpp
                             ${FUSE_WINDOWS_SRC}/service.cpp
                             ${FUSE_WINDOWS_SRC}/unmounter.cpp
                             ${FUSE_WINDOWS_SRC}/utility.cpp
)

# Are we building integration tests?
if (NOT TARGET test_integration)
    return()
endif()

set(FUSE_WINDOWS_TESTING_SRC ${FUSE_WINDOWS_SRC}/testing)
set(FUSE_WINDOWS_TESTING_INC ${FUSE_WINDOWS_INC}/testing)

target_include_directories(test_integration PRIVATE
                                            ${FUSE_WINDOWS_SRC}
)

target_sources(test_integration PRIVATE
                                ${FUSE_WINDOWS_TESTING_INC}/directory_monitor.h
                                ${FUSE_WINDOWS_TESTING_INC}/printers.h
                                ${FUSE_WINDOWS_TESTING_INC}/wrappers.h
                                ${FUSE_WINDOWS_TESTING_SRC}/directory_monitor.cpp
                                ${FUSE_WINDOWS_TESTING_SRC}/platform_tests.cpp
                                ${FUSE_WINDOWS_TESTING_SRC}/printers.cpp
                                ${FUSE_WINDOWS_TESTING_SRC}/utility.cpp
                                ${FUSE_WINDOWS_TESTING_SRC}/wrappers.cpp
)

=== tools/gfxworker/tests/integration/CMakeLists.txt ===
add_executable(gfxworker_test_integration
    executable_dir.h
    executable_dir.cpp
    main.cpp
    server_client_test.cpp
)

target_link_libraries(gfxworker_test_integration
    PRIVATE
    libgfxworker
    MEGA::SDKlib
)

# Look for the libraries needed for both integration and unit tests.
if(VCPKG_ROOT)
    find_package(GTest CONFIG REQUIRED)
    target_link_libraries(gfxworker_test_integration PRIVATE GTest::gtest)
else()
    pkg_check_modules(gtest REQUIRED IMPORTED_TARGET gtest)
    target_link_libraries(gfxworker_test_integration PRIVATE PkgConfig::gtest)
endif()

# Adjust compilation flags for warnings and errors for libgfxworker
target_platform_compile_options(
    TARGET gfxworker_test_integration
    WINDOWS /W4
            /we4800 # Implicit conversion from 'type' to bool. Possible information loss
    UNIX $<$<CONFIG:Debug>:-ggdb3> -Wall -Wextra -Wconversion
)

if(ENABLE_SDKLIB_WERROR)
    target_platform_compile_options(
        TARGET gfxworker_test_integration
        WINDOWS /WX
        UNIX  $<$<CONFIG:Debug>: -Werror>
    )
endif()

# prepare test data
# Integration tests require the following files to work
file(GLOB TESTING_AUX_FILES "test_data/*")
add_custom_command(
    TARGET gfxworker_test_integration POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy ${TESTING_AUX_FILES} $<TARGET_FILE_DIR:gfxworker_test_integration>
    COMMENT "Copying test files for gfxworker integration tests."
)

=== build/templates/megasdk/PKGBUILD ===
##
 # @file build/templates/sdk/PKGBUILD
 # @brief script to generate package sdk for ArchLinux
 #
 # (c) 2013-2016 by Mega Limited, Auckland, New Zealand
 #
 # This file is part of the MEGA SDK - Client Access Engine.
 #
 # SDK is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 #
 # @copyright Simplified (2-clause) BSD License.
 #
 # You should have received a copy of the license along with this
 # program.
##

pkgname=megasdk
pkgver=megasdk_VERSION
pkgrel=`cat MEGA_BUILD_ID || echo "1"`
epoch=
pkgdesc="MEGA SDK - Client Access Engine"
arch=('i686' 'x86_64')
url="https://mega.io/developers"
license=("https://github.com/meganz/sdk/blob/master/LICENSE")
groups=()
depends=('glibc>=2.37')
makedepends=('unzip' 'wget' 'ca-certificates' 'cmake' 'zip' 'python3' 'autoconf-archive' 'nasm')
checkdepends=()
optdepends=()
provides=("megasdk=${pkgver}")
replaces=()
backup=()
options=(!lto) # ffmpeg is not relocatable
install=megasdk.install
changelog= #TODO
source=("./${pkgname}_$pkgver.tar.gz"
)
noextract=()
md5sums=('MD5SUM') # generated with makepkg -g
validpgpkeys=()

prepare() {
	cd "$pkgname-$pkgver"
	if [ -f /opt/vcpkg.tar.gz ]; then
		tar xzf /opt/vcpkg.tar.gz
	fi
}

build() {
	set -x

	cd "$pkgname-$pkgver"
	megasrcdir="${PWD}"
	megabuilddir="${megasrcdir}/build_dir"

	if [ -d "${megasrcdir}/vcpkg" ]; then
		export VCPKG_DEFAULT_BINARY_CACHE=/opt/persistent/vcpkg_cache
		mkdir -p ${VCPKG_DEFAULT_BINARY_CACHE}
		vcpkg_root="-DVCPKG_ROOT=${megasrcdir}/vcpkg"
	fi

	cmake --version
	cmake ${vcpkg_root} -DCMAKE_VERBOSE_MAKEFILE=ON -DCMAKE_BUILD_TYPE=RelWithDebInfo -S "${megasrcdir}" -B "${megabuilddir}"
	cmake --build "${megabuilddir}" ${BUILD_PARALLEL_JOBS}


	touch build-stamp
}

check() {
	cd "$pkgname-$pkgver"
}

package() {
	cd "$pkgname-$pkgver"
	megasrcdir="${srcdir}/${pkgname}-${pkgver}"
	megabuilddir="${megasrcdir}/build_dir"

	cmake --install "${megabuilddir}" --prefix $pkgdir
}
